function [pod_all,diag_S,pod_cov,sig_cov,k_seq,pod_modes] = pod_conv_mtraj_v2(File_snapshots_test,File_pod_mtraj,saveON)
% test convergenence of POD basis and the eigenvalues 

if ~exist([File_pod_mtraj,'.mat'],'file')
    %% 1. Load or compuate Kmat
    load(File_snapshots_test,'Kmat_Mtraj','u_Mtraj');
    [nx,~, num_test] = size(Kmat_Mtraj);
    nx2 = length(u_Mtraj(:,1,1));
    % if nx2 == nx
    %    Kmat_Mtraj = Kmat_Mtraj(2:end-1,2:end-1,:) ; % Drop the zero boundaries nx = nx2-2
    % end
    
    
    
    %% 2. compute POD basis for different sample sizes
    %---- generate POD basis functions
    if num_test>=100                   % set a seq of numbers of trajs, for convergence test
        k_ind = linspace(1,log10(num_test),10);
        k_seq = floor(10.^k_ind);    %[100,200,300,400,500,600];
    else
        k_seq = floor(linspace(10,num_test,10));
    end
    
    conv_sum  = length(k_seq);
    pod_cov   = cell(conv_sum,1);
    sig_cov   = cell(conv_sum,1);
    pod_modes = [1,5,10,15];
    % pod_all   = zeros(nx2,nx2);    %% ***** set pod_all to have BC =0
    
    for k = 1:conv_sum
        KmatM       = Kmat_Mtraj(:,:,1:k_seq(k));
        kmat_mean   = mean(KmatM,3);
        [V,Lambda]  = eig(kmat_mean);
        diag_S      = diag(Lambda);
        [diag_S, Ind]= sort(diag_S,'descend');   V = V(:,Ind);
        pod_all = V; %    pod_all(2:end-1,2:end-1)      = V;
        pod_save     = pod_all(:,pod_modes);
        pod_cov{k,1} = pod_save;
        sig_cov{k,1} = diag_S;
    end
    if saveON==1
        save(File_pod_mtraj,'pod_cov','pod_modes','k_seq','kmat_mean','pod_all','diag_S','sig_cov');  % save the last pod_all
    end
end

load(File_pod_mtraj,'pod_cov','pod_modes','k_seq','pod_all','diag_S','sig_cov')
end



