function u1 = Burgers1D_FEM_semi...
    (opt, domain, x, e_conn, n_gauss, Mass, S, P, ...
    u0, f0, f1, filename_shape, nodes_nondir, bn, ...
    ker_nonlfunc_grad, ker_nonlfunc)
%--------------------------------------------------------------------------
% This routine use semi-implicit method for time discretization
%--------------------------------------------------------------------------
n_nodes   = size(u0,1);
utest     = nodes_nondir;     % related to number of test functions
utral     = nodes_nondir;     % related to number of trial functions
N1        = length(utest);
N3        = length(utral);
RInd1     = 1 : N1;
CInd1     = 1 : N3;    % column index relates to number of trial functions
u1        = u0; % initial guess with correct boundary
%%{
%----test differential filter
opt.r = 4*domain.h;
%--- step 1, at t=t0, u0 is given, cal v0
v0 = diff_filter(u0,opt.r,Mass,S,nodes_nondir,bn.dir(:,1));
%--- step 2, at t=t0, u0 is given, cal v0bar
v0bar = diff_filter(v0,opt.r,Mass,S,nodes_nondir,bn.dir(:,1));
% plot(x,u0,x,v0,'ro-',x,v0bar,'kx-',x,v0star,'g^-')
%--- step 3, solve AD equation (semi-implicit)
v0star= 2*v0-v0bar;
N=3;
v0star1 = AD_diff_filter(v0,opt.r,N,Mass,S,nodes_nondir,bn.dir(:,1));
plot(x,u0,x,v0,'ro-',x,v0bar,'kx-',x,v0star,'g^-',x,v0star1,'cs-')
pause(.05)
%}
Mat_A = Mass;
Mat_B = opt.parm_e*S;
A_f   = Mat_A + domain.t*Mat_B;
rhs_f = -Mat_A*u0 - domain.t*f1;
% nonlinear function
if isempty(ker_nonlfunc)==1
    d_nonlin = sparse(n_nodes,n_nodes);
    Nh       = sparse(n_nodes, 1);
end
[~, T2] = FEM_assemble_trilinear_1D_Burgers...
    (x,e_conn,n_gauss,u0,filename_shape);

d_nonlin = d_nonlin+T2;

Ac  = A_f+ domain.t*(d_nonlin);
bc  = -( rhs_f );
A   = Ac(utral,utral);
b   = bc(utral,1)-Ac(utral,bn.dir(:,1))*bn.dir(:,2); % -Ac(utest,bn.dir(:,1))*zeros(size(bn.dir(:,1),1)) % since it is newton step
%--------------------------------
u1(utral)  = A\b;




