function u0 = get_IC(filenames,fem_settings,ic_modes,num_test,saveON)
%--- specify initial conditions
%
% FL remark: not clear about these options, but following previous code
% TODO: generate M IC's and save them to ICdata.mat % CM: done
    File_ic = filenames.File_ic;

if exist(File_ic,'file')
    
    fprintf(1, ['The ICs are generated in previous run under directory:', char(File_ic), '\n']);

else
    
    fem_mesh = fem_settings.fem_mesh;
    x        = fem_mesh.x;
    opt      = fem_settings.opt;
    
    nodes_nondir = fem_settings.nodes_nondir;
    t_initial    = fem_settings.t_initial;
    u            = fem_settings.u;
    bn           = fem_settings.bn;
    
    if opt.ic == 3
        
        u0 = burgers1d_step_ic(x);
        
    elseif opt.ic == 4
        
        u0 = 8*opt.parm_e*pi.*sin(pi.*x)./(5+4.*cos(pi.*x));
        
    elseif opt.ic ==2
        
        u0_modes = burgers1d_ic_modes(fem_mesh,ic_modes); % pre-assign the matrix form of sine modes
        
        u0_mtraj = zeros(length(x),num_test);
        
        for i =1:num_test
            
            u0_weight = normrnd(1/2,0.2,ic_modes,1); % generate the randomized weights of each sine mode
            
            u0_mtraj(:,i) = u0_modes*u0_weight;
            
        end
        
        u0 = u0_mtraj; % return the ICs for multiple trajectories
        
    else
        u0 = fem1d_ic(opt.ic,x,bn,u,nodes_nondir,t_initial);
    end
    
    if saveON==1
        
        save(File_ic,'u0_mtraj');
        
        fprintf(1, ['Estimator data has been stored to ', char(File_ic), '\n']);
        
    end
    
end