function [f_func, fcv, u_x_func, u_x_v, u_t_func, u_t_v] = fem1d_f_cal(u)
%--------------------------------------------------------------------------
% The use of this subroutine is to calcuate the RHS function f_func, the 
% first derivative function of u, u_x_func, and the time derivative 
% function of u, u_t_func. 
%--------------------------------------------------------------------------
syms x y t

u_t  = diff(u, 't', 1);
u_x  = diff(u, 'x', 1);
u_xx = diff(u, 'x', 2);

f_sym    = -u_xx-pi^2*u*(1-u^2);

f_c      = char(f_sym);
fcv      = symvar(f_c);
f_func   = FEM_sym_2_func(f_sym);

u_x_func = FEM_sym_2_func(u_x);
ux_v     = char(u_x);
u_x_v    = symvar(ux_v);

u_t_func = FEM_sym_2_func(u_t);
ut_v     = char(u_t);
u_t_v    = symvar(ut_v);

