function u0 = fem1d_ic(opt_ic,x,bn,u,nodes_nondir,t)
%--------------------------------------------------------------------------
% To generate initial conditions
% Three choices are supported so far: 
% 1. zeros with correct boundary condition;
% 2. load from some data files;
% 5. exact solution plus random perturbation.
%--------------------------------------------------------------------------
[n_nodes, dim] = size(x);
if dim~=1
    error('Not 1D \n');
end
switch opt_ic
    case 0 % initial guess plus correct Dirichlet BC
        u0 = zeros(n_nodes,1);
        u0(bn.dir(:,1),1) = bn.dir(:,2);
    case 1 % load a vector from a data or a vector
        filename = [];
        load(filename,'u_save');
        u0 = u_save(:,end);        
    case 2 % initial condition function is known
        u0 = FEM_function_value(u.ifunc, u.ivar, x, t); 
%         u0(nodes_nondir,1) = u0(nodes_nondir,1)+0.001*rand(size(nodes_nondir,1),1);
end
