function [ Err_max, Err_L2, Err_H1_semi, Err_H1]= fem1d_pod_error...
    (x, e_conn, u_h, u_pod, n_gauss, filename_shape)
%-----------------------------------------------------------------------
% calculate errors between finite element solution and the POD-ROM
% solution on the same mesh
%-----------------------------------------------------------------------
dim            = size(x , 2);
% N              = max(e_conn(:)); % Since it may use bubble function
[n_elements, nel_dof]= size(e_conn);
%--- initialization
load(filename_shape,'W_x_g','W_w_g','W_phi','W_p_x')
if dim==2
    load(filename_shape,'W_p_y')
end

Err_max        = max(abs(u_h-u_pod));
Err_L2_square         = 0;
Err_H1_semi_square    = 0;

if (dim==1)
    for n_el = 1:n_elements
        nodes_local              = e_conn(n_el,:);
        % x_local                  = x(nodes_local,:);
        w_g     = W_w_g(:,n_el);
        phi     = W_phi(:,(n_el-1)*nel_dof+1:n_el*nel_dof);
        phi_x   = W_p_x(:,(n_el-1)*nel_dof+1:n_el*nel_dof);
        
        u_h_local                = u_h(nodes_local,:);
        u_h_local_g              = phi*u_h_local;
        u_pod_local              = u_pod(nodes_local,:);
        u_pod_local_g            = phi*u_pod_local;
        
        ux_h_local_g             = phi_x*u_h_local;
        ux_pod_local_g           = phi_x*u_pod_local;
        
        Err_L2_square      = Err_L2_square      + w_g'*(u_pod_local_g-u_h_local_g).^2;  
        Err_H1_semi_square = Err_H1_semi_square + w_g'*(ux_pod_local_g-ux_h_local_g).^2;
    end
    Err_H1_square      = Err_L2_square+Err_H1_semi_square;
    
    Err_L2      = sqrt(Err_L2_square);
    Err_H1_semi = sqrt(Err_H1_semi_square);
    Err_H1      = sqrt(Err_H1_square);
end

