function a_Mtraj = get_at_data(u_Mtraj,pod_all,r)
% get the first r coefficients a(t) of the POD basis

[nx,nt,M] = size(u_Mtraj); 
[nx2,nx3] = size(pod_all); % pod_all does not contain the zero eigenvectors, thus nx2 = nx >= nx3
if nx3<r; fprintf('\n  r is bigger than the number of POD basis! Use a smaller r. \n '); end

pod_rTrans  = pod_all(:,1:r)';  
a_Mtraj = zeros(r,nt,M);
for m= 1:M
    a_Mtraj(:,:,m) =  pod_rTrans*u_Mtraj(:,:,m); 
end

% figure; plot(a_Mtraj(:,:,1)');              % see if the trajectories are smooth

end