function [TildeA,TildeB] = burgers1d_assemble_quadratic_ansatz(B_m,r, svd_method)


if strcmp(svd_method,'standard')==1
    %---- standard truncated SVD
    
    TildeA = B_m(1:r^2);
    TildeB = B_m(r^2+1:end);
    TildeA = reshape(TildeA,r,r)';
    TildeB = reshape(TildeB,r,r,r);
    
elseif strcmp(svd_method,'decoupled')==1
    %---- decoupled truncated SVD
    TildeA = B_m(1:r,:)';
    TildeB = B_m(r+1:end,:);
    TildeB= reshape(TildeB,r,r,r);
end

end