function [matrix_e] = burgers1d_dtsvd_lhs_mat(a_snap)
%------------------------------------------
% Assemble the matrix E in the DD-VMS-ROM
% Intends for the decoupled truncated SVD (DTSVD)
% a_snap is the matrix of size M*r
% output is E matrix of size MrX(r+r^2)
%------------------------------------------

[r,M] = size(a_snap);

matrix_e = zeros(M,r+r^2);

for j =1:M
    
    aj = a_snap(:,j);
    A1 = aj';

    B1 = aj*aj';
    B1 = reshape(B1,[],1)';
    
    matrix_e(j,:) = [A1,B1];
    
end



return;