function [TildeA,TildeB] =burgers1d_tsvd_invp_solver(U,S,V,b_rhs,r,choose_rank)
%-----------------------------------------
% A solver using standard truncated SVD
% to solve the Ax = b problem
% Output:
% TildeA rXr matrix
% TildeB rXrXr tensor
%-----------------------------------------

%% truncated SVD
%------------------------------------------
%---extract first j modes
Sa = S(1:choose_rank,1:choose_rank);
Ua = U(:,1:choose_rank);
Va = V(:,1:choose_rank);

eigen_Sr = diag(Sa);
S_diagi=1./eigen_Sr;
S_inv = diag(S_diagi);

%--- multiplying to the left
B_m = Va*S_inv*Ua'*b_rhs;

%% assemble tildeA and tildeB
%------------------------------------------
TildeA_vec = B_m(1:r^2);
TildeB_vec = B_m(r^2+1:end);
TildeA = reshape(TildeA_vec,r,r)';
TildeB = reshape(TildeB_vec,r,r,r);


end