function tau_r  = burgers1d_tsvd_rhs(tensor_r,tensor_d,a_snap_r,a_snap_d)
%------------------------------------------
% Assemble the vector f in the DD-VMS-ROM
% Intends for the standard truncated SVD (TSVD)
% a_snap is the matrix of size M*r
% output is tau_r of size MXr
%------------------------------------------


[r,M] = size(a_snap_r);
[d,~] = size(a_snap_d);

tau_r = zeros(r*M,1);

for j =1:M
    
    count = (j-1)*r;
    
    for k = 1:r
       
        tau_r(count+k) = a_snap_d(:,j)'*tensor_d(:,:,k)*a_snap_d(:,j) ...
            - a_snap_r(:,j)'*tensor_r(:,:,k)*a_snap_r(:,j);
        
    end
end
% for k=1:r
%
%     for j =1:M
%
%         tau_r(j,k) = a_snap_d(1:d,j)'*tensor_d(1:d,1:d,k)*...
%             a_snap_d(1:d,j) ...
%             - a_snap_r(:,j)'*tensor_r(:,:,k)*a_snap_r(:,j);
%
%     end
% end

return;
