function M = fem1d_bilinear( kernel, phi, test, w_g )
%-----------------------------------------------------------------------
%  twod_bilinear.m - routine to compute \int{ kernel*phi, test }
%
%  Variables:     kernel
%                        Kernel function in the integral evaluated
%                        at the Gauss points
%
%                 phi
%                        matrix of element test functions evaluated
%                        at the Gauss points (dim: n_gauss, n_dof)
%
%                 test
%                        matrix of test functions evaluated at the
%                        Gauss points (dim: n_gauss, n_dof)
%
%                 w_g
%                        Row vector of Gauss weights
%-----------------------------------------------------------------------

  M = test'*diag( w_g.*kernel )*phi;