function [Tr_x0,Tr_0x]=pod1d_trilinear_loc_fun(pod_u,x, e_conn,n_gauss,flag)
%------------------------------------------
% This assemble method could avoid using large memory
%
% Feb 17, 2021, C. Mou
%%------------------------------------------

global W_w_g W_phi W_p_x

%------------------------------------------
dim_pod = size(pod_u,2); % number of POD basis
Tr_x0=zeros(dim_pod,dim_pod);
Tr_0x = Tr_x0;
%Tr_00 = Tr_x0;

%------------------------------------------
[N, dim ] = size(x);
[n_elements, nel_dof] = size(e_conn);



for itrg = 1:n_elements
    
    %------------------------------------------
    %elem_no = itrg;
    nodes_loc   = e_conn(itrg,:);
    
    w_g      = W_w_g(:,itrg);
    phi      = W_phi(:,(itrg-1)*nel_dof+1:itrg*nel_dof);
    p_x      = W_p_x(:,(itrg-1)*nel_dof+1:itrg*nel_dof);
    
    %------------------------------------------
    u_ker_loc = phi*pod_u(nodes_loc,flag);
    
    u1_pod_loc =  pod_u(nodes_loc,:);
    
    %------------------------------------------
    %tri_00_loc = fem1d_bilinear(u_ker_loc, phi, phi, w_g);   %(h*u, h)
    
    tri_x0_loc = fem1d_bilinear(u_ker_loc, p_x, phi, w_g );  %(h*u_x, h)
    
    tri_0x_loc = fem1d_bilinear(u_ker_loc, phi,p_x, w_g);   %(h_x*u, h)
    
    %------------------------------------------
    %Tr_00 = Tr_00 + u1_pod_loc'*tri_00_loc*u1_pod_loc;
       
    Tr_x0 = Tr_x0 + u1_pod_loc'*tri_x0_loc*u1_pod_loc;
    
    Tr_0x = Tr_0x + u1_pod_loc'*tri_0x_loc*u1_pod_loc;
    
        
end

return
