function printArray2tex(A,B,figpath)
% print Array A to tex 
% [n,m] = size(A); 
% for nn = 1:n
%     fprintf('A(%i,j)',nn); 
%     for mm=1:m
%         fprintf('& %2.2f  ', A(nn,mm)); 
%     end
%     fprintf('\\\\ \n'); 
% end


 [~,~,k] = size(B); 

 
 % figure; 
% for kk=1:k
%     subplot(2,ceil(k/2),kk)
%     imagesc(B(:,:,kk)); colorbar;  
%     title(sprintf('k=%i',kk)); hold on; 
% end

fig= figure;  % plot of solution field
space_subplots = [0.05,0.02];
ha = tight_subplot(2,ceil(k/2),space_subplots,[0.1,0.08],[0.09,0.06]);
for kk=1:k
    axes(ha(kk)); imagesc(B(:,:,kk));   colorbar;  title(sprintf('k=%i',kk));
    % caxis([0 0.82]);
    if kk==1 || kk== 6; yticklabels('auto'); else; yticklabels(''); end % ylabel('x');  title('FOM'); 
    if kk<6; xticklabels(''); end % xlabel('Time'); hold on;
end



%% get the number of subplots in gcf; 
cells_axes = findobj(gcf,'type','axes');
N = length(cells_axes);
pos1 = zeros(N,1); pos2 = zeros(N,1);
for n = 1:N
    pos1(n) = cells_axes(n).Position(1);
    pos2(n) = cells_axes(n).Position(2);
end
Ncols = numel(unique(pos1));
Nrows = numel(unique(pos2));

%% set figure size for plot of B
figname = [figpath,'B_estimator']; 
% width = 540+270*(Ncols-1); height = 240+120*(Nrows-1);   % 9:4
width = 400+200*(Ncols-1); height = 310+120*(Nrows-1);   % 9:4
set(gcf, 'Position',  [100, 1000, width, height]);    % set figure position + size [x , x, width height]
% ftsz =10; mksz =10; % if save to -depsc
% set(findall(gcf,'-property','FontSize'),'FontSize',ftsz);
% set(findall(gcf,'-property','MarkerSize'),'MarkerSize',mksz);
% print([figname,'.pdf'],'-dpdf', '-bestfit');

ftsz =14; mksz =14; % if save to -depsc
set(findall(gcf,'-property','FontSize'),'FontSize',ftsz);
set(findall(gcf,'-property','MarkerSize'),'MarkerSize',mksz);
print([figname,'.eps'],'-depsc');
