% function filenames = set_filenames() 

%% --- set file names

Folder_save = SAVE_DIR; % '../../FEM_Data/';
Filename0   = ['Burgers1D_FEM_case_',num2str(opt.es),num2str(opt.rhs),...
    '_P', num2str(domain.elem_order), '_h', num2filename(domain.h),...
    '_nu',num2str(num2filename(opt.parm_e)),...
    '_dt', num2str(num2filename(domain.t)),...
    '_cta', num2str(num2filename(opt.theta)), '_'];
File_shape  = [Folder_save, Filename0,'shape'];
File_smm    = [Folder_save, Filename0, 'FEIC_SMM'];
File_mesh    = [Folder_save, Filename0,'mesh'];
File_snap    = [Folder_save, Filename0,'snap_']; % for multiple run of FEM % %06/11/2021
File_ic    = [Folder_save, Filename0,'ic_mtraj']; % for multiple run of FEM % %06/11/2021

% white noise data
File_dW =  [Folder_save, Filename0,'dW']; % for multiple run of FEM % %06/11/2021
File_fig    = ['SAVE_DIR_fig', Filename0, 'fig'];

% save POD for multiple trajectories
Filename1 = strrep(Filename0,'FEM','POD');
File_pod    = [Folder_save, Filename1,'mtraj'];

% estimator data from multiple trajectories and single trajectory
Filename2 = strrep(Filename0,'FEM','EST');
File_estimator = [Folder_save, Filename2,'mtraj'];
File_single_traj = [Folder_save, Filename2,'single_traj'];

% ROM results
Filename3 = strrep(Filename0,'FEM','ROM');
File_rom    = [Folder_save, Filename3];


% for test of covergence of POD
Filename4 = strrep(Filename0,'FEM','mPOD');
File_pod_mtraj = [Folder_save, Filename4,'mtraj'];


%--- set output
outputInfo.fig_num    = 1;
outputInfo.fig_evo_p  = 0;
outputInfo.fig_evo    = 1;
outputInfo.cal_err    = 0;              % output error values to screen
outputInfo.save_data  = 1;              % choose whether saving data or not



%--- files structures
filenames = struct(...
     'Folder_save', Folder_save,...
     'Filename0',   Filename0,...
     'File_shape',  File_shape,...
     'File_smm',    File_smm,...
     'File_snap',   File_snap,...
     'File_mesh',    File_mesh,...
     'File_ic',       File_ic,...
     'File_dW', File_dW,...
     'File_pod',    File_pod,...
     'File_estimator',      File_estimator,...
     'File_single_traj',File_single_traj,...
     'File_rom',    File_rom,...
     'File_pod_mtraj', File_pod_mtraj, ...
     'File_fig',    File_fig,...
     'outputInfo',  outputInfo ...
    );



