function [pred_err,errAvg_tseq,u_err] = getPredict_error(a_Mtraj_new,romInfo_seq,gapSeq,u_r_err)
% get the prediction error for each SROM model: trajectory averaged 

n_tseq = length(gapSeq); 
[nx,tN,M_pred]  =size(a_Mtraj_new(:,:,:));


if ~exist('u_r_err','var'); u_r_err = zeros(tN,M_pred); end
pred_err    = zeros(n_tseq,1);       % error: trajectory and M-sample averaged 
errAvg_tseq = zeros(n_tseq,M_pred);  % error: trajectory  averaged 
u_err       = errAvg_tseq;           % error in u trajectory  averaged 
for i =1:n_tseq
    gap  = gapSeq(i); tInd  = 1:gap:tN; tNrom  = length(tInd);
    romInfo  = romInfo_seq{i};
    SigmaT   = diag(romInfo.res);
    errMtraj = zeros(tNrom,M_pred); 
    for m = 1:M_pred
        Xfom           = a_Mtraj_new(:,tInd,m); X0 = Xfom(:,1);
        X              = runROM_1traj(X0,romInfo.dt,tNrom-1,romInfo); %,SigmaT);
        errMtraj(:,m)  = vecnorm(Xfom - X);  
    end
    figure; plot(errMtraj(:,1))
    errAvg_tseq(i,:) = mean(errMtraj,1); 
    pred_err(i)      = mean(mean(errMtraj)); 
    u_err(i,:)       = mean(sqrt(errMtraj.^2 + u_r_err(tInd,:)),1);
end

end
